unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdHTTP, Spin, ComCtrls;

type
  TForm1 = class(TForm)
    IdHTTP1: TIdHTTP;
    Button1: TButton;
    Edit1: TEdit;
    SpinEdit1: TSpinEdit;
    Memo1: TMemo;
    ComboBox1: TComboBox;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    Edit2: TEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button2: TButton;
    GroupBox3: TGroupBox;
    TreeView1: TTreeView;
    Label7: TLabel;
    Label8: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//nahradi mezery plusy
function mezera(s:string):string;
 var
  i:integer;
begin
 result:='';
 for i:=1 to length(s) do
  if s[i]=' ' then
   result:=result+'+'
  else
   result:=result+s[i];
end;

//z daneho textu ziska obsah tagu
function obsah(tag:string):string;
 var
  j:integer;
begin
    j:=1;
    while (tag[j]<>'>') do
     inc(j);
    result:='';
    repeat
     inc(j);
     result:=result+tag[j];
    until (tag[j+1]='<')or(j>length(tag)-2);

end;

//z tagu ziska obsah daneho parametru
function parametr(par,tag:string):string;
 var
  i,j:integer;
  ok:boolean;
begin
 i:=0;
 j:=0;
 ok:=true;
 while (i<Length(tag)) and ok do
  begin
   inc(i);
   if(par[1]=tag[i])then
    begin
     j:=1;
     while(par[j+1]=tag[i+j]) do
      inc(j);
     if j=Length(par) then
      ok:=false;
    end;
  end;
 result:='';
 if not ok then
  begin
   i:=i+j;
   while(tag[i]<>'"')do
    inc(i);
   while(tag[i+1]<>'"')do
    begin
     inc(i);
     result:=result+tag[i];
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
 var
  i:integer;
  s:string;
begin
  Memo1.Clear;
  GroupBox2.Visible:=false;
  GroupBox3.Visible:=false;
  try
   //ziskani seznamu stanic
   Memo1.Text := IdHTTP1.Get('http://'+edit1.text+'/SeznamStanic');
  except
   on e:Exception do
    begin
     ShowMessage('Chyba spojeni.');
     exit;
    end;
  end;

  //naplneni prvniho ComboBoxu stanicemi
  ComboBox1.Clear;
  for i:=1 to Memo1.Lines.Count-2 do
   begin
    s:=Memo1.Lines.Strings[i];
    ComboBox1.Items.Add(obsah(s));
   end;

 ComboBox2.Items:=ComboBox1.Items;
 ComboBox3.Items:=ComboBox1.Items;
 ComboBox3.Items.Insert(0,'-neni zadano-');
 GroupBox2.visible:=true;
end;

procedure TForm1.Button2Click(Sender: TObject);
 var
  url:string;
  radek,idvlak,idspoj,prestup:integer;
  s,t,u,prvni,posledni,odjezd,prijezd,o2,p2:string;
  spoj,vlak:TTreeNode;
begin
 GroupBox3.Visible:=false;
 Memo1.Clear;
 TreeView1.Items.Clear;
 //pozadavek na server
 url:='http://'+edit1.text+'/NajdiSpojeni?odkud='+
      mezera(ComboBox1.Items.Strings[ComboBox1.itemindex])+
      '&kam='+mezera(ComboBox2.Items.Strings[ComboBox2.itemindex])+
      '&odjezd='+mezera(Edit2.Text)+'&prestupy='+
      IntToStr(SpinEdit2.Value)+'&spojeni='+IntToStr(SpinEdit3.Value);
 if ComboBox3.ItemIndex>0 then
  url:=url+'&pres='+mezera(ComboBox3.Items.Strings[ComboBox3.itemindex]);
 Memo1.Text := IdHTTP1.Get(url);

 //zpracovani vysledku ze serveru
 s:=Memo1.Lines.Strings[0];
 if(s[2]='C')then //chyba
  begin
   ShowMessage(obsah(s));
  end
 else
  begin
   GroupBox3.Visible:=true;
   //vypsani pocatecni a konecne stanice od GroupBoxu
   GroupBox3.Caption:='Spojeni: '+ComboBox1.Items.Strings[ComboBox1.itemindex]
                      +' - '+ComboBox2.Items.Strings[ComboBox2.itemindex];
   radek:=1;
   //ziskavani dat z jednotlivych radku vystupu
   while (radek<Memo1.Lines.Count-2) do
    begin
       //pridani spoje do TreeViewu
       spoj:=TreeView1.Items.Add(TreeView1.Items.GetFirstNode,'Odjezd: ');
       //zapamatovani jeho pozice
       idspoj:=TreeView1.Items.Count-1;
       odjezd:='';
       prestup:=-1;
       //ziskavani dat v ramci jednoho spoje
       while trim(Memo1.Lines.Strings[radek+1])<>'</Spoj>' do
        begin
         inc(radek);
         s:=trim(Memo1.Lines.Strings[radek]);
         //pridani vlaku do daneho spoje v TreeView
         vlak:=TreeView1.Items.AddChild(spoj,'Vlak '+parametr('cislo',s));
         //zapamatovani pozice vlaku v komponente
         idvlak:=TreeView1.Items.Count-1;
         prvni:='';
         o2:='';
         inc(prestup);
         //ziskavani dat v ramci jedne linky
         while trim(Memo1.Lines.Strings[radek+1])<>'</Linka>' do
          begin
           inc(radek);
           s:=trim(Memo1.Lines.Strings[radek]);
           if s[2]='S' then
            begin //stanice
             u:=parametr('prijezd',s); //prijezd do stanice
             prijezd:=u;               //prijezd celeho spoje do sveho cile
             p2:=u;                    //prijezd vlaku do cile
             if u='' then u:='     ';
             t:=u+' ';
             u:=parametr('odjezd',s);  //odjezd ze stanice
             if odjezd='' then        //odjezd celeho spoje ze sveho zacatku
              odjezd:=u;
             if o2='' then           //odjezd z prvni zastavky vlaku
              o2:=u; 
             if u='' then u:='     ';
             posledni:=obsah(s);     //jmeno stanice + ulozeni do cilove stanice vlaku
             if prvni='' then        //ulozeni pocatecni stanice vlaku
              prvni:=posledni;
             TreeView1.Items.AddChild(vlak,t+u+' '+posledni); //vypsani informaci o vlaku v dane stanici
            end;
           if s[2]='P' then
            begin //vypsani poznamky
             t:='Poznamka: '+obsah(s);
             TreeView1.Items.AddChild(vlak,t);
            end;
          end;
           inc(radek);
          //doupraveni mista a casu odjezdu a prijezdu u daneho vlaku
         TreeView1.Items.Item[idvlak].Text:=TreeView1.Items.Item[idvlak].Text+' '+prvni+' - '+posledni+
                                            '  '+o2+' - '+p2;
        end;
          //doupraveni casu odjezdu a prijezdu u daneho vlaku
       TreeView1.Items.Item[idspoj].Text:=TreeView1.Items.Item[idspoj].Text+odjezd+
                                          ' Prijezd: '+prijezd+' Prestupu: '+IntToStr(prestup);
       inc(radek,2);
    end;
  end;
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
 IdHTTP1.Port:=SpinEdit1.Value;
end;

end.
